% Voraussetzung: DCG-Regeln, Lexikon abgetrennt.
:- dynamic forests/3.  

parse(Ws, Tree) :-
        retractall(forests(_,_,_)),
        add(forests(0,[],[])),
        reduce(0,Ws),
        start_symbol(S),
        length(Ws,N),
        forests(N,[S],[Tree]).

shift(I,[W|Ws]) :-
        word(W,A), 
        forests(I,Roots,Forest),
        J is I + 1,
        add(forests(J,[A|Roots],[[A,W]|Forest])),
        fail.
shift(I,[W|Ws]) :-
        J is I + 1, reduce(J,Ws).
shift(I,[]).
reduce(I,_Ws) :-
    forests(I,Roots,Forest),
    reduce(I,Roots,Forest),
    fail. 
reduce(I,Ws) :-
    shift(I,Ws).

reduce(I,Roots,Forest) :- 
    (B ---> Beta),
    roots(Beta,Bs),
    reverse(Bs,BetaRev),
    append(BetaRev,AlphaRev,Roots),
    length(BetaRev,N),
    length(BetaForest,N), % N unbekannte Baeume
    append(BetaForest,AlphaForest,Forest),
    reverse(BetaForest,BetaTrees),
    NewForest = [[B|BetaTrees]|AlphaForest],
    NewRoots = [B|AlphaRev],
    add(forests(I,NewRoots,NewForest)),
    reduce(I,NewRoots,NewForest),
    fail.
reduce(I,_Roots,_Forest).

add(T) :- (known_instance(T) -> true ; assertz(T)).
known_instance(Term) :- 
    \+ \+ (numbervars(Term,const,0,_), Term).

roots((A,B),Cats) :-
    !, roots(A,CatsA), roots(B,CatsB),
    append(CatsA,CatsB,Cats).
roots((A;B),Cats) :-
    !, (roots(A,Cats) ; roots(B,Cats)).
roots([W|Ws],Cats) :-
    !, roots(Ws,CatsWs), Cats = [[W]|CatsWs].
roots([],Cats) :-
    !, Cats = [].
roots({Code},Cats) :-
    !, call(Code), Cats = [].
roots(Cat,[Cat]).
