% Cocke/Younger/Kasami-Erkenner

parse([W|Ws]) :-
    retractall(kante(_,_,_)), % alte Tabelle loeschen
    parse(0,[W|Ws]).

parse(I,[W|Ws]) :-
    scan(I,W),
    J is I+1,
    complete(I,J),
    parse(J,Ws).
parse(J,[]) :-
    kante(0,A,J),
    start_symbol(A).

scan(I,W) :-
    ((A ---> [W]) ; word(W,A)), % Lexikoneintrag
    J is I+1,
    add(kante(I,A,J)),
    fail.      % weitere Lexikoneintraege zu W ?
scan(_,_).

add(Fakt) :-
    (\+ \+ (numbervars(Fakt,c,0,_), Fakt) 
    -> true ; % nichts tun, falls Fakt[c/X] beweisbar
        assert(Fakt) 
    ).
complete(K,J) :-
    (K = 0 -> true
    ; I is K-1, complete(I,K,J), complete(I,J)
    ).

complete(I,K,J) :- % I < K < J
    kante(I,B,K),
    kante(K,C,J),
    (A ---> B,C),
    add(kante(I,A,J)),
    fail.
complete(I,K,J) :-
    (I = 0 -> true
    ; L is I-1, complete(L,K,J)
    ).
