:- dynamic kante/5. % kante(I,J,A,Alpha,Beta)

erkenne(Wortfolge) :-
    retractall(kante(_I,_J,_A,_Alpha,_Beta)),
    predict(0),
    erkenne(0,Wortfolge).

erkenne(I,[Wort|Rest]) :-
    J is I + 1,              
    scan(I,J,Wort),
    erkenne(J,Rest).
erkenne(I,[]) :-        % Eingabe erkannt?                      
    start_symbol(S),  
    kante(0,I,S,_Alpha,[]).

scan(I,J,Wort) :-         % i -Wort-> j=i+1
    ( word(Wort,A),
        closure(I,J,A,[Wort],[])
    ; ( kante(K,I,A,Alpha,([Wort],Beta))
      ; kante(K,I,A,Alpha,[Wort]),Beta = []
      ), append(Alpha,[[Wort]],AlphaW),        
        closure(K,J,A,AlphaW,Beta)
    ), fail.
scan(_,_,_).
closure(I,J,B,Beta,[]) :-
    (add(kante(I,J,B,Beta,[]))
    -> complete(I,J,B) ; true).
closure(I,J,A,Alpha,(B,Bs)) :-
    !, add(kante(I,J,A,Alpha,(B,Bs))),
    predict(J,B).
closure(I,J,A,Alpha,B) :-
    add(kante(I,J,A,Alpha,B)),
    predict(J,B).

complete(I,J,B) :-
    ( kante(K,I,A,Alpha,(B,Beta))
    ; kante(K,I,A,Alpha,B), Beta = []
    ),
    append(Alpha,[B],AlphaB),
    closure(K,J,A,AlphaB,Beta),
    fail.
complete(_,_,_).
predict(0) :- 
    start_symbol(S), predict(0,S), fail.
predict(0).

predict(J,A) :-                
    (A ---> Alpha), closure(J,J,A,[],Alpha),  
    fail.                        
predict(J,A) :-       
    (A ---> []),      % mit Loeschkanten verketten,
    complete(J,J,A),  % auch wenn diese schon
    fail.             % in der Tabelle sind!
predict(_,_).
add(Fact) :-
    ((var(Fact) ; known(Fact))
    -> fail ; assertz(Fact)).
known(Term) :- 
    \+ \+ (numbervars(Term,c,0,_), Term).
