parse(A,I,J) :-
    (head(B,A) ; B=A),
    leaf(B,I,I2,J2,J),  
    headcorner(B,A,I,I2,J2,J).

headcorner(B,A,I,I2,J2,J) :-            %      A
    ( I=I2, J2=J, B=A                   %    /   \
    ; (C ---> Gamma),                    %   /     \
      head((C ---> Gamma),Alpha,B,Beta), %  i--- C ---j
      reverse(Alpha,AlphaRev),          %     / \
      parse_list_rev(AlphaRev,I,I3,I2), %    /   \
      parse_list(Beta,J2,J3),           %   /     \
      headcorner(C,A,I,I3,J3,J)        % i3-i2 B j2-j3 
    ).
leaf(A,I,I2,J2,J) :-
    ( (A ---> []),
        I=I2, I2=J2, J2=J
    ; append(_,I2,I), I2 = [W|J2], append(_,J,J2),
        (word(W,A) ; A = [W])   % , lexhead(A)
    ).  
head((C ---> Gamma),Alpha,B,Beta) :-
    roots(Gamma,GammaList),
    head(B,C),
    append(Alpha,[B|Beta],GammaList).
parse_list_rev([],_,J,J).
parse_list_rev([A|As],I,K,J) :-
    parse_rev(A,I,L,J),
    parse_list_rev(As,I,K,L).

parse_rev(A,I,K,J) :-
    append(_,K,I), append(_,J,K),
    parse(A,K,J).

parse_list([B|Bs],I,J) :-
    parse(B,I,K), parse_list(Bs,K,J).
parse_list([],I,J) :- I = J.

roots((A,B),Cats) :-
    !, roots(A,CatsA), roots(B,CatsB),
    append(CatsA,CatsB,Cats).
roots((A;B),Cats) :-
    !, (roots(A,Cats) ; roots(B,Cats)).
roots([W|Ws],Cats) :-
    !, roots(Ws,CatsWs), Cats = [[W]|CatsWs].
roots([],Cats) :-
    !, Cats = [].
roots({Code},Cats) :-
    !, call(Code), Cats = [].
roots(Cat,[Cat]).
