parse(Ws,Tree) :-
    start_symbol(S), parse(S,Ws,[],Tree).
parse(A,I,J,Tree) :-
    (head(B,A) ; B=A),
    leaf([B|Trees],I,I2,J2,J),  
    headcorner([B|Trees],A,I,I2,J2,J,Tree).
leaf([A|Trees],I,I2,J2,J) :-
    ( (A ---> []),
        I=I2, I2=J2, J2=J, Trees=[]
    ; append(_,I2,I), I2=[W|J2], append(_,J,J2),
        (word(W,A), Trees=[W] ; A=[W], Trees=[])
    ).  
headcorner([B|BTs],A,I,I2,J2,J,Tree) :-   
    ( I=I2, J2=J, B=A, Tree=[B|BTs]       %       A
    ; (C ---> Gamma),                      %     /   \ 
      head((C ---> Gamma),Alpha,B,Beta),   %    /  ?  \
      reverse(Alpha,AlphaRev),            %  i-?- C -?-j       
      parse_list_rev(AlphaRev,I,I3,I2,AlphaRs),%/ | \
      reverse(AlphaRs,AlphaTs),           % Alpha B Beta
      parse_list(Beta,J2,J3,BetaTs),      % /  | / \ |  \
      append(AlphaTs,[[B|BTs]|BetaTs],Ts),%i3-i2 BTs j2-j3             
      headcorner([C|Ts],A,I,I3,J3,J,Tree)  
    ).

head((C ---> Gamma),Alpha,B,Beta) :-
    roots(Gamma,GammaList),
    head(B,C),
    append(Alpha,[B|Beta],GammaList).

parse_list_rev([],_,J,J,[]).
parse_list_rev([A|As],I,K,J,[Tree|Trees]) :-
    parse_rev(A,I,L,J,Tree),
    parse_list_rev(As,I,K,L,Trees).

parse_rev(A,I,K,J,Tree) :-
    append(_,K,I), append(_,J,K),
    parse(A,K,J,Tree).

parse_list([B|Bs],I,J,[Tree|Trees]) :-
    parse(B,I,K,Tree), parse_list(Bs,K,J,Trees).
parse_list([],I,J,[]) :- I = J.

roots((A,B),Cats) :-
    !, roots(A,CatsA), roots(B,CatsB),
    append(CatsA,CatsB,Cats).
roots((A;B),Cats) :-
    !, (roots(A,Cats) ; roots(B,Cats)).
roots([W|Ws],Cats) :-
    !, roots(Ws,CatsWs), Cats = [[W]|CatsWs].
roots([],Cats) :-
    !, Cats = [].
roots({Code},Cats) :-
    !, call(Code), Cats = [].
roots(Cat,[Cat]).
