parse(Words) :-
        start_symbol(S), parse(S,Words,[]).
parse(A,I,J) :-
        scan(B,I,K), 
        leftcorner(B,A,K,J).

scan(B,I,K) :-
        ( (B ---> []), I=K
        ; (word(W,B) ; B=[W]), I = [W|K] ).
leftcorner(B,A,I,J) :-
        ( B=A, I=J
        ; (C ---> Gamma),
            roots(Gamma,[B|Beta]),
            parse_list(Beta,I,K),
            leftcorner(C,A,K,J)
        ).
parse_list([B|Bs],I,J) :-
        parse(B,I,K), parse_list(Bs,K,J).
parse_list([],I,J) :- I = J.

roots((A,B),Cats) :-
    !, roots(A,CatsA), roots(B,CatsB),
    append(CatsA,CatsB,Cats).
roots((A;B),Cats) :-
    !, (roots(A,Cats) ; roots(B,Cats)).
roots([W|Ws],Cats) :-
    !, roots(Ws,CatsWs), Cats = [[W]|CatsWs].
roots([],Cats) :-
    !, Cats = [].
roots({Code},Cats) :-
    !, call(Code), Cats = [].
roots(Cat,[Cat]).
